{% extends 'base.html.twig' %}

{% block body -%}
<main class='main-content bgc-grey-100'>
<div id='mainContent'>
    <div id="syncComp">
        <div class="d-flex justify-content-start align-items-center flex-wrap flex-md-nowrap">
            <div>
                <h1>Aggiornamento manuale dati {{ provider.name }}</h1>
                <h4 class="mb-3 d-none d-lg-block">Risultati da aggiornare rispetto al registro elettronico</h4>
            </div>
            <div class="ms-md-auto ">
                <div class="pb-1 text-end d-none d-md-block" v-if="loadedTime!==null">Caricato il ${ loadedTime.toISOString().substring(0,16).replace("T"," ") }</div>
                <div>
                    <button class="btn mb-3" @click="loadData" :class="{'btn-primary': !loading, 'btn-warning': loading}" :disabled="loading"><span v-if="loading">Caricamento</span><span v-else>Ricarica</span> dati dal provider</button>
                </div>
            </div>
        </div>

        <ul class="nav nav-pills" role="tablist">
            <li class="nav-item" role="presentation" v-for="tab in tabs"><a @click.prevent="currentTab = tab.id" role="tab" class="nav-link" :class="{active: currentTab == tab.id}" href="#">${ tab.name }</a></li>
        </ul>

        <div class="tab-content">
            <template v-for="tab in tabs">
            <div role="tabpanel" class="tab-pane active pt-3" v-if="currentTab == tab.id">
                <template v-if="data[tab.id] !== undefined">
                    <div class="card mb-3">
                        <div class="card-header" :class="{'border-bottom-0': !tab.importCardOpen}" @click="tab.importCardOpen = !tab.importCardOpen">Da importare (${ toImportCount })</div>

                        <div class="card-body" v-if="tab.importCardOpen">
                            <template v-if="toImportCount > 0">
                                <synccomp-table :entities="data[tab.id].toImport" :entity-type="tab.id" default-action="import" :default-delete-options="tab.defaultDeleteOptions" initial-state-label="Da importare"
                                                url="{{ path('config_provider_import_data', {'providerId' :  provider.id}) }}" @newentityinserted="onNewEntityInserted"></synccomp-table>
                            </template>
                            <div v-else>
                                Non ci sono dati da importare
                            </div>
                        </div>
                    </div>

                    <div class="card" style="margin-bottom: 1rem">
                        <div class="card-header" :class="{'border-bottom-0': !tab.updateCardOpen}" @click="tab.updateCardOpen = !tab.updateCardOpen">Da aggiornare (${ toUpdateCount })</div>

                        <div class="card-body" v-if="tab.updateCardOpen">
                            <template v-if="toUpdateCount > 0">
                                <synccomp-table :entities="data[tab.id].toUpdate" :entity-type="tab.id" default-action="update" :default-delete-options="tab.defaultDeleteOptions"  initial-state-label="Da aggiornare"
                                                url="{{ path('config_provider_update_data', {'providerId' :  provider.id}) }}" @newentityinserted="onNewEntityInserted"></synccomp-table>
                            </template>
                            <div v-else>
                                Non ci sono dati da aggiornare
                            </div>
                        </div>
                    </div>

                    <div class="card" v-if="showDeleteArea" style="margin-bottom: 1rem">
                        <div class="card-header" :class="{'border-bottom-0': !tab.deleteCardOpen}" @click="tab.deleteCardOpen = !tab.deleteCardOpen">Da ${ canDelete ? 'eliminare' : 'cestinare' } (${ toDeleteCount })</div>

                        <div class="card-body" v-if="tab.deleteCardOpen">
                            <template v-if="toDeleteCount > 0">
                                <synccomp-table :entities="data[tab.id].toDelete" :entity-type="tab.id" default-action="trash" :default-delete-options="tab.defaultDeleteOptions"
                                                delete-url="{{ path('config_provider_remove_data', {'providerId' :  provider.id}) }}"
                                                url="{{ path('trash_do_trash') }}" :initial-state-label="canDelete ? 'Da eliminare' : 'Da cestinare'"
                                                :show-main-action="tab.canBeTrashed" main-action-label="Cestina" :show-delete-action="canDelete" :extra-columns="extraDeleteColumns"
                                                @newentityinserted="onNewEntityInserted"></synccomp-table>
                            </template>
                            <div v-else>
                                Non ci sono dati da cancellare
                            </div>
                        </div>
                    </div>

                    <div class="card" v-if="entityHasIncompatibilitiesReasons">
                        <div class="card-header" :class="{'border-bottom-0': !tab.invalidCardOpen}" @click="tab.invalidCardOpen = !tab.invalidCardOpen">Non importabili/incompleti/incompatibili (${ invalidEntitiesCount })</div>

                        <div class="card-body" v-if="tab.invalidCardOpen">
                            <template v-if="invalidEntitiesCount > 0">
                                <div class="table-responsive">
                                    <table class="table table-striped">
                                        <tr>
                                            <th>Nome</th>
                                            <th>Motivazione</th>
                                        </tr>
                                        <tr v-for="(entity, id) in data[tab.id].invalid" :key="id">
                                            <td>${ entity.entityName }</td>
                                            <td>${ entity.error }</td>
                                        </tr>
                                    </table>
                                </div>
                            </template>
                            <div v-else>
                                Non ci sono dati da cancellare
                            </div>
                        </div>
                    </div>
                </template>
                <div v-else-if="loading">
                    Caricamento dati in corso....
                </div>
                <div v-else>
                    Non ci sono dati da visualizzare
                </div>
            </div>
            </template>
        </div>
    </div>
</div>
</main>
{% endblock %}

{% block javascripts -%}
    {{ parent() }}

    <script type="text/javascript">
        window.addEventListener('load', () => {
            VueCreateApp({
                delimiters: ['${', '}'],
                data: () => ({
                    loading: false,
                    loadedTime: null,
                    data: {},
                    tabs: [
                        {id: "sectors", name: "Settori", defaultDeleteOptions: {}, canBeTrashed: false, importCardOpen: false, updateCardOpen: false, deleteCardOpen: false, invalidCardOpen: false},
                        {id: "groups", name: "Classi", defaultDeleteOptions: {deleteOnLdap: false, deleteOnGApps: '0'}, canBeTrashed: false, importCardOpen: false, updateCardOpen: false, deleteCardOpen: false, invalidCardOpen: false},
                        {id: "students", name: "Studenti", defaultDeleteOptions: {deleteOnLdap: false, deleteOnGApps: '0', gAppsOu: '/'}, canBeTrashed: true, importCardOpen: false, updateCardOpen: false, deleteCardOpen: false, invalidCardOpen: false},
                        {id: "teachers", name: "Docenti", defaultDeleteOptions: {deleteOnLdap: false, deleteOnGApps: '0', gAppsOu: '/'}, canBeTrashed: true, importCardOpen: false, updateCardOpen: false, deleteCardOpen: false, invalidCardOpen: false},
                        {id: "subjects", name: "Materie", defaultDeleteOptions: {}, canBeTrashed: false, importCardOpen: false, updateCardOpen: false, deleteCardOpen: false, invalidCardOpen: false}
                    ],
                    executionQueue: [],
                    queueWorking: false,
                    currentTab: 'sectors',
                    canDelete: {{ canDelete ? "true" : "false" }}
                }),
                computed: {
                    currentTabData() {
                        return this.tabs.find(tab => tab.id === this.currentTab);
                    },
                    showDeleteArea() {
                        return this.canDelete || this.currentTabData.canBeTrashed;
                    },
                    toImportCount() {
                        return this.data[this.currentTabData.id] !== undefined && this.data[this.currentTabData.id].toImport !== undefined ? Object.keys(this.data[this.currentTabData.id].toImport).length : 0;
                    },
                    toUpdateCount() {
                        return this.data[this.currentTabData.id] !== undefined && this.data[this.currentTabData.id].toUpdate !== undefined ? Object.keys(this.data[this.currentTabData.id].toUpdate).length : 0;
                    },
                    toDeleteCount() {
                        return this.data[this.currentTabData.id] !== undefined && this.data[this.currentTabData.id].toDelete !== undefined ? Object.keys(this.data[this.currentTabData.id].toDelete).length : 0;
                    },
                    invalidEntitiesCount() {
                        return this.data[this.currentTabData.id] !== undefined && this.data[this.currentTabData.id].invalid !== undefined ? Object.keys(this.data[this.currentTabData.id].invalid).length : 0;
                    },
                    entityHasIncompatibilitiesReasons() {
                        return this.currentTab === "groups" || this.currentTab === "students" || this.currentTab === "teachers"
                    },
                    extraDeleteColumns() {
                        return this.entityHasIncompatibilitiesReasons ? [{key: 'reason', name: 'Motivo cancellazione'}] : [];
                    }
                },
                methods: {
                    loadData: function () {
                        this.loading = true;
                        const $this = this;
                        axios.post('{{ path('config_provider_load_data', {'id' :  provider.id}) }}')
                        .then(function (response) {
                            if (typeof response.data !== "object" || response.data.data === undefined) {
                                alert(response.data.error !== undefined ? response.data.error : "Impossibile caricare i dati dal server");
                                $this.loading = false;
                                return;
                            }

                            var actionTypes = ['toImport', 'toUpdate', 'toDelete'];
                            var newData = {};
                            var actionType;
                            var tabId;
                            for (var tabIdx in $this.tabs) {
                                tabId = $this.tabs[tabIdx].id;
                                newData[tabId] = {};
                                for (var dataTypeIdx in actionTypes) {
                                    actionType = actionTypes[dataTypeIdx];
                                    newData[tabId][actionType] = {};

                                    if (response.data.data[tabId] === undefined || response.data.data[tabId][actionType] === undefined) {
                                        continue;
                                    }

                                    for (var entityId in response.data.data[tabId][actionType]) {
                                        newData[tabId][actionType][entityId] = {
                                            data: response.data.data[tabId][actionType][entityId],
                                            state: 0,
                                            error: null
                                        }
                                    }
                                }

                                if(response.data.data.invalidEntities[tabId] !== undefined) {
                                    newData[tabId]['invalid'] = response.data.data.invalidEntities[tabId];
                                }
                            }

                            $this.data = newData;
                            $this.loading = false;
                            $this.loadedTime = new Date();
                        }).catch(function () {
                            $this.loading = false;
                            alert("Impossibile caricare i dati dal server");
                        });
                    },
                    onNewEntityInserted(payload) {
                        let entityIdx;
                        if (payload.entityType === "sectors") {
                            for (entityIdx in this.data.groups.toImport) {
                                if (this.data.groups.toImport[entityIdx].data.sectorId === payload.entityId) {
                                    this.data.groups.toImport[entityIdx].data.internalSectorId = payload.newEntityId;
                                }
                            }

                            for (entityIdx in this.data.groups.toUpdate) {
                                if (this.data.groups.toUpdate[entityIdx].data.sectorId === payload.entityId) {
                                    this.data.groups.toUpdate[entityIdx].data.internalSectorId = payload.newEntityId;
                                }
                            }
                        } else if (payload.entityType === "groups") {
                            for (entityIdx in this.data.students.toImport) {
                                if (this.data.students.toImport[entityIdx].data.groupId === payload.entityId) {
                                    this.data.students.toImport[entityIdx].data.internalGroupId = payload.newEntityId;
                                }
                            }

                            for (entityIdx in this.data.students.toUpdate) {
                                if (this.data.students.toUpdate[entityIdx].data.groupId === payload.entityId) {
                                    this.data.students.toUpdate[entityIdx].data.internalGroupId = payload.newEntityId;
                                }
                            }
                        }
                    },

                },
                components: {
                    'synccomp-table': SyncTable
                },
                mounted: function () {
                    var $this = this;
                    setTimeout(function () {
                        $this.loadData();
                    }, 500);
                }
            }).mount("#syncComp");
        });
    </script>

{% endblock %}